<?php
class ControllerModuleHideMyOc extends Controller {
	private $error = array();
	private $extension_id = 'hide_my_oc';
	private $techstriders_data = array();
	private $htaccess = '';
	private $backup_htaccess ='';
	private $route ='extension/module';


	public function __construct($registry) {
		parent::__construct($registry);

		if(version_compare(VERSION, '2.3.0.0') < 0 ) {
			$this->route = 'module';
		}

		$this->load->language($this->route .'/'.$this->extension_id);
		$this->load->model('setting/setting');
		$this->load->model('tool/image');
	
		$this->load->model($this->extension_id.'/'.$this->extension_id);

		$this->techstriders_data['extension_id'] = $this->extension_id;
		$this->config->load($this->extension_id);
		
		$this->techstriders_data['techstriders'] = ($this->config->get('techstriders')) ? $this->config->get('techstriders') : array();
		
		$this->htaccess = str_replace('system/', '', DIR_SYSTEM).'.htaccess';
		$this->create_htaccess();
		
		/*** Extension is taking backup of your store's .htaccess file for safty purpose. ***/
		$this->backup_htaccess = DIR_APPLICATION.'model/'.$this->extension_id.'/htaccess-backup.txt';
				
	}

	public function index() {
		
		$this->document->setTitle($this->language->get('page_heading_title'));
		$data['code'] = '';

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			
			$this->update_setting($this->request->post);

			$this->response->redirect($this->url->link($this->route .'/'.$this->extension_id, 'token=' . $this->session->data['token'], true));
		}

		if(isset($this->session->data['success'])) {
			$this->techstriders_data['success'] = $this->session->data['success'];
			unset($this->session->data['success']);
		} else {
			$this->techstriders_data['success'] = '';
		}

		if(isset($this->session->data['code'])) {
			$this->techstriders_data['code'] = nl2br(sprintf($this->language->get('text_add_code'),str_replace($this->config->get('hide_my_oc_old_admin')."/../", "", $this->htaccess),$this->getRewriteBase(),$this->session->data['code']));
			unset($this->session->data['code']);
		} else {
			$this->techstriders_data['code'] = '';
		}

		$this->techstriders_data['heading_title'] = $this->language->get('heading_title');
		$this->techstriders_data['button_save_htaccess'] = $this->language->get('button_save_htaccess');

		// Texts
		$this->techstriders_data['text_module'] = $this->language->get('text_module');
		$this->techstriders_data['text_edit'] = $this->language->get('text_edit');
		$this->techstriders_data['text_save_setting'] = $this->language->get('text_save_setting');

		// Buttons
		$this->techstriders_data['button_save'] = $this->language->get('button_save');
		$this->techstriders_data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$this->techstriders_data['error_warning'] = $this->error['warning'];
		} else {
			$this->techstriders_data['error_warning'] = '';
		}

		$this->techstriders_data['techstriders'] = $this->getAllSetting();
		$this->techstriders_data['saved_setting'] = $this->getSavedSetting();

		$this->load->model('localisation/language');

		$this->techstriders_data['languages'] = $this->model_localisation_language->getLanguages();
		

		$this->techstriders_data['error_file_permission'] = '';
		if(!$this->is_file_writable($this->htaccess)) {
			$this->techstriders_data['error_file_permission'] = sprintf($this->language->get('error_file_permission'),$this->htaccess);
		}

	
		// Dynamic
		$urls = $this->model_hide_my_oc_hide_my_oc->getUrls();
		$this->techstriders_data['techstriders']['seo']['table']['body'] = (!empty($urls)) ? $urls : $this->techstriders_data['techstriders']['seo']['table']['body'];
		

		$this->techstriders_data['breadcrumbs'] = array();

		$this->techstriders_data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		if(version_compare(VERSION, '2.3.0.0') < 0 ) {
			$this->techstriders_data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_module'),
				'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'], true)
			);
		} else {
			$this->techstriders_data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_module'),
				'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true),
			);
		}


		if (!isset($this->request->get['module_id'])) {
			$this->techstriders_data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link($this->route.'/'.$this->extension_id, 'token=' . $this->session->data['token'], true)
			);
		} else {
			$this->techstriders_data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link($this->route.'/'.$this->extension_id, 'token=' . $this->session->data['token'] . '&module_id=' . $this->request->get['module_id'], true)
			);
		}
	
		if(version_compare(VERSION, '2.3.0.0') < 0 ) {
			$this->techstriders_data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], true);
		} else {
			$this->techstriders_data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true);
		}

		$this->techstriders_data['action'] = $this->url->link($this->route.'/'.$this->extension_id, 'token=' . $this->session->data['token'], true);		
		$this->techstriders_data['save_and_stay'] = $this->url->link($this->route.'/'.$this->extension_id.'/save_setting', 'token=' . $this->session->data['token'], true);
		$this->techstriders_data['token'] = $this->session->data['token'];
		
		$this->techstriders_data['file_htaccess'] = $this->getHtaccess();
		$this->techstriders_data['text_support'] = $this->language->get('text_support');
		$this->techstriders_data['placeholder'] = $this->model_tool_image->resize('no_image.png', 100, 100);
		

		/* Registery */
		$this->techstriders_data['registered'] = $this->config->get($this->extension_id.'_registered');

		if(VERSION < 2) {

			$this->document->addScript('//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js');
			$this->document->addStyle('//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css');

			$this->data['techstriders_data'] = $this->techstriders_data;
			$this->load->model('design/layout');

			$this->data['layouts'] = $this->model_design_layout->getLayouts();

			$this->template = 'module/'.$this->extension_id.'.tpl';
			$this->children = array(
				'common/header',
				'common/footer'
			);

			$this->response->setOutput($this->render());

		} else  {
			$data['techstriders_data'] = $this->techstriders_data;

			$data['header'] = $this->load->controller('common/header');
			$data['column_left'] = $this->load->controller('common/column_left');
			$data['footer'] = $this->load->controller('common/footer');

			if( VERSION < 2.2 ) {
				$this->response->setOutput($this->load->view($this->route.'/'.$this->extension_id.'.tpl', $data));
			} else {
				$this->response->setOutput($this->load->view($this->route.'/'.$this->extension_id, $data));
			}
			
		}
		
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', $this->route.'/'.$this->extension_id)) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

	private function getAllSetting() {

		foreach ($this->techstriders_data['techstriders'] as $key1 => $techstriders) {
			if(isset($techstriders['fields']) AND is_array($techstriders['fields'])) {
				foreach ($techstriders['fields'] as $key2 => $field) { 
					if(isset($this->request->post[$field['name']])) { 
						$this->techstriders_data['techstriders'][$key1]['fields'][$key2]['value'] = $this->request->post[$field['name']];
					} else if($this->config->get($field['name'])) {

						$this->techstriders_data['techstriders'][$key1]['fields'][$key2]['value'] = $this->config->get($field['name']);
					}

					
					// Input image.
					if( $field['type'] =='image' ) {
						if (isset($this->request->post[$field['name']]) && is_file(DIR_IMAGE . $this->request->post[$field['name']])) {
							$this->techstriders_data['techstriders'][$key1]['fields'][$key2]['src'] = $this->model_tool_image->resize($this->request->post[$field['name']], 100, 100);
						} elseif ($this->config->get($field['name']) && is_file(DIR_IMAGE . $this->config->get($field['name']))) {
							$this->techstriders_data['techstriders'][$key1]['fields'][$key2]['src'] = $this->model_tool_image->resize($this->config->get($field['name']), 100, 100);
						} else {
							$this->techstriders_data['techstriders'][$key1]['fields'][$key2]['src'] = $this->model_tool_image->resize('no_image.png', 100, 100);
						}
					}
					
										
					// check validation
					if(isset($this->error[$field['error']])) {
						$this->techstriders_data['techstriders'][$key1]['fields'][$key2]['error'] = $this->error[$field['error']];
					} else {
						$this->techstriders_data['techstriders'][$key1]['fields'][$key2]['error'] = '';
					}
					
					$this->techstriders_data['techstriders'][$key1]['fields'][$key2]['label'] = isset($field['label']) ? $this->language->get($field['label']) : '';
					$this->techstriders_data['techstriders'][$key1]['fields'][$key2]['help'] = ($this->language->get($field['help']) != $field['help']) ? $this->language->get($field['help']) : '';
					
				}
			}

			if(isset($techstriders['table']) AND is_array($techstriders['table'])) {

				if(isset($techstriders['table']['field_name'])) {
					$config = explode('[', $techstriders['table']['field_name'][1]);
					$saved = $this->config->get($config[0]) ;
					if(!empty($saved)) {
						$this->techstriders_data['techstriders'][$key1]['table']['body'] = $saved;
					}
					
				}
			}
		}

		return $this->techstriders_data['techstriders'];
	}

	public function generate_code($setting = array()) {
		$data = array(); 

		if (!empty($setting)) {
			$data = $setting;
		} else if($this->request->post) {
			$data = $this->request->post;
		} else {
			$data = $this->getSavedSetting();
		}
		
		$code  = "";
		$code .= "\n\n";
		$code .= '#'.$this->extension_id;
		$code .= "\n";
		
		if(!empty($data[$this->extension_id.'_theme'])) {
			if(VERSION < 2.2) {
				$code .= 'RewriteRule ^'.$data[$this->extension_id.'_theme'].'/(.*) '.sprintf($this->config->get('path_theme'),$this->config->get('config_template')).'$1 [QSA,L]';
				$code .= "\n";
			} else {
				$code .= 'RewriteRule ^'.$data[$this->extension_id.'_theme'].'/(.*) '.sprintf($this->config->get('path_theme'),$this->config->get('theme_default_directory')).'$1 [QSA,L]';
				$code .= "\n";
			}
			
		}
		
		if(!empty($data[$this->extension_id.'_js'])) {
			$code .= 'RewriteRule ^'.$data[$this->extension_id.'_js'].'/(.*) '.$this->config->get('path_js').'$1 [QSA,L]';
			$code .= "\n";
		}

		if(!empty($data[$this->extension_id.'_image_cache'])) {
			$code .= 'RewriteRule ^'.$data[$this->extension_id.'_image_cache'].'/(.*) '.$this->config->get('path_cache').'$1 [QSA,L]';
			$code .= "\n";
		}

		if(!empty($data[$this->extension_id.'_image_cache'])) {
			$code .= 'RewriteRule ^'.$data[$this->extension_id.'_image'].'/(.*) '.$this->config->get('path_image').'$1 [QSA,L]';
			$code .= "\n";
		}

		if(!empty($data[$this->extension_id.'_new_admin'])) {
			$code .= 'RewriteRule ^'.$data[$this->extension_id.'_new_admin'].'(.*) '.$this->getRewriteBase().''.$data[$this->extension_id.'_old_admin'].'/$1 [QSA,L]';
			$code .= "\n";
		}
		

		// Enable gzip via .htaccess 
		if($data[$this->extension_id.'_gzip']) {
			$code .= '<IfModule mod_filter.c>
    					AddOutputFilterByType DEFLATE "application/atom+xml" \
                                  "application/javascript" \
                                  "application/json" \
                                  "application/ld+json" \
                                  "application/manifest+json" \
                                  "application/rdf+xml" \
                                  "application/rss+xml" \
                                  "application/schema+json" \
                                  "application/vnd.geo+json" \
                                  "application/vnd.ms-fontobject" \
                                  "application/x-font-ttf" \
                                  "application/x-javascript" \
                                  "application/x-web-app-manifest+json" \
                                  "application/xhtml+xml" \
                                  "application/xml" \
                                  "font/eot" \
                                  "font/opentype" \
                                  "image/bmp" \
                                  "image/svg+xml" \
                                  "image/vnd.microsoft.icon" \
                                  "image/x-icon" \
                                  "text/cache-manifest" \
                                  "text/css" \
                                  "text/html" \
                                  "text/javascript" \
                                  "text/plain" \
                                  "text/vcard" \
                                  "text/vnd.rim.location.xloc" \
                                  "text/vtt" \
                                  "text/x-component" \
                                  "text/x-cross-domain-policy" \
                                  "text/xml"

					</IfModule>';
			$code .= "\n";
		}

		// enable expiry headers
		if($data[$this->extension_id.'_expires_headers']) {
			$code .= '<IfModule mod_expires.c>
						# Enable expirations
						ExpiresActive On 
						# Default directive
						ExpiresDefault "access plus 1 month"
						# My favicon
						ExpiresByType image/x-icon "access plus 1 year"
						# Images
						ExpiresByType image/gif "access plus 1 month"
						ExpiresByType image/png "access plus 1 month"
						ExpiresByType image/jpg "access plus 1 month"
						ExpiresByType image/jpeg "access plus 1 month"
						# CSS
						ExpiresByType text/css "access plus 1 month"
						# Javascript
						ExpiresByType application/javascript "access plus 1 year"
						</IfModule>';
			$code .= "\n";
		}

		$code .= '#'.$this->extension_id;
		$code .= "\n\n";

		return $code;
	}

	private function is_file_writable($file) {

		return (file_exists( $file ) && is_writable($file)) ? true : false;
	}

	private function create_htaccess() {
		if(!is_file($this->htaccess)){
			rename (DIR_APPLICATION.'../.htaccess.txt', $this->htaccess);
		}
	}
	private function getHtaccess() {

		return file_get_contents($this->htaccess);
	}

	private function getRewriteBase() {
		return $rewriteBase = trim(explode("\n", explode('RewriteBase', $this->getHtaccess())[1])[0]);
	}

	public function saveFile($file_content = '',$file_path ='') {
		$file_path = (!empty($file_path)) ?  $file_path : $this->htaccess;
	
		if($this->is_file_writable($this->htaccess)) {
			$fileHandler = @fopen($file_path,"r+");
			@ftruncate($fileHandler, 0);
			file_put_contents($file_path, $file_content);
			@fclose($fileHandler);
		} else {
			die(sprintf($this->language->get('error_file_permission'),$this->htaccess));
		}
		
	}

	public function write_in_file($setting = array()) {
		
		$file_content = $this->getHtaccess();

		if(strpos($file_content, '#'.$this->extension_id) !== false) {

			$search = '#'.$this->extension_id;

			$contant = explode($search, $file_content);
			$contant[1] = str_replace($search, "", trim($this->generate_code($setting)));

			$file_content = implode($search, $contant);
			$this->saveFile($file_content);
			
		} else {

			$search = 'RewriteBase '. $this->getRewriteBase();
			$file_content = substr_replace($file_content, $search.$this->generate_code($setting), strpos($file_content, $search), strlen($search));

			$this->saveFile($file_content);
		}

	}

	private function getSavedSetting() {
		$data = array();
		$data[$this->extension_id.'_theme'] = $this->config->get($this->extension_id.'_theme');
		$data[$this->extension_id.'_js'] = $this->config->get($this->extension_id.'_js');
		$data[$this->extension_id.'_image_cache'] = $this->config->get($this->extension_id.'_image_cache');
		$data[$this->extension_id.'_image'] = $this->config->get($this->extension_id.'_image');
		$data[$this->extension_id.'_new_admin'] = $this->config->get($this->extension_id.'_new_admin');
		$data[$this->extension_id.'_old_admin'] = $this->config->get($this->extension_id.'_old_admin');
		$data[$this->extension_id.'_install'] = $this->config->get($this->extension_id.'_install');
		$data[$this->extension_id.'_gzip'] = $this->config->get($this->extension_id.'_gzip');
		$data[$this->extension_id.'_expires_headers'] = $this->config->get($this->extension_id.'_expires_headers');
		$data[$this->extension_id.'_seo'] = $this->config->get($this->extension_id.'_seo');
		$data[$this->extension_id.'_search'] = $this->config->get($this->extension_id.'_search');
		$data[$this->extension_id.'_admin_footer'] = $this->config->get($this->extension_id.'_admin_footer');
		$data[$this->extension_id.'_admin_logo'] = $this->config->get($this->extension_id.'_admin_logo');
		$data[$this->extension_id.'_order_id'] = $this->config->get($this->extension_id.'_order_id');
		return $data;
	}

	private function update_setting($setting = array()) {

		$this->model_setting_setting->editSetting($this->extension_id, $setting);
		$this->model_hide_my_oc_hide_my_oc->insert($setting);
	
		$this->session->data['success'] = $this->language->get('text_success');
	
		if(isset($setting[$this->extension_id.'_install']) && $setting[$this->extension_id.'_install']) {
			$this->session->data['code'] = $this->generate_code($setting);
		} else {
			$this->write_in_file($setting);
		}
	}

	public function activate() {
		
	}

	public function save_setting() {
		$json = array();
		if(isset($this->request->post['setting']) && !empty($this->request->post['setting'])) {
			$setting = json_decode(html_entity_decode( $this->request->post['setting'] , ENT_QUOTES, "UTF-8"),true);
			if(is_array($setting)) {

				$this->update_setting($setting);

				$json['redirect'] = str_replace('&amp;', '&', $this->url->link($this->route.'/'.$this->extension_id, 'token=' . $this->session->data['token'], true));
			
			} else {
				$json['error'] =  $this->language->get('error_setting');
			}
			
		} else {
			$json['error'] =  $this->language->get('error_setting');
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

	public function install() {
		$db_check = $this->db->query("SHOW COLUMNS FROM `" . DB_PREFIX . "url_alias` LIKE '".$this->extension_id."'");
        if (!$db_check->num_rows) {
            $this->db->query("ALTER TABLE  `".DB_PREFIX."url_alias` ADD  `".$this->extension_id."` TINYINT NOT NULL");
        }

        if(!is_file($this->backup_htaccess)) {
			$this->saveFile($this->getHtaccess(),$this->backup_htaccess);
		}
	}

	public function uninstall() {
		$db_check = $this->db->query("SHOW COLUMNS FROM `" . DB_PREFIX . "url_alias` LIKE '".$this->extension_id."'");
        if ($db_check->num_rows) {
        	$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE ".$this->extension_id." = 1");
            $this->db->query("ALTER TABLE  `".DB_PREFIX."url_alias` DROP  `".$this->extension_id."`");
        }
        //$this->saveFile(file_get_contents($this->backup_htaccess));
        //unlink($this->backup_htaccess);
	}
}